#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <string.h>
//#include <termios.h>
#include <conio.h>

FILE *infile;



// Registers


//accumulator and scratch registers
struct r {
    unsigned char regA;
    unsigned char regB;
    unsigned char regC;
    unsigned char regD;
    unsigned char regE;
    unsigned char regH;
    unsigned char regL;
};

union regs {
    unsigned char regs[7];
    struct r r;
} regs;

struct address {
    unsigned char regH;
    unsigned char regL;
};

// PC and stack
union stack {
    struct address stack [8];
    unsigned short stk [8];
} stack;

unsigned char stackptr;

//flags
unsigned char flagParity;
unsigned char flagSign;
unsigned char flagCarry;
unsigned char flagZero;

//16khmemory
unsigned char memory [0x4000] =
{
    0x46,0x64,0x00,0x44,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x30,0xb,0x28,0x7,

    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x36,0xc8,0x2e,0x0,0xc7,0x3c,0x2e,0x68,0x77,0x0,0x46,0x3c,
    0x0,0xc6,0x3c,0xdc,0x48,0x68,0x0,0x7,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,

    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,

    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
    0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,0x0,
};

// mnemonic symbols for opcodes
char *mnems[] = {"HLT", "HLT", "RLC", "RFC", "ADI", "RST", "LAI", "RET", "INB", "DCB", "RRC", "RFZ", "ACI", "RST", "LBI", "RET",
                 "INC", "DCC", "RAL", "RFS", "SUI", "RST", "LCI", "RET", "IND", "DCD", "RAR", "RFP", "SBI", "RST", "LDI", "RET",
                 "INE", "DCE", " ! ", "RTC", "NDI", "RST", "LEI", "RET", "INH", "DCH", " ! ", "RTZ", "XRI", "RST", "LHI", "RET",
                 "INL", "DCL", " ! ", "RTS", "ORI", "RST", "LLI", "RET", " ! ", " ! ", " ! ", "RTP", "CPI", "RST", "LMI", "RET",
                 "JFC", "INP", "CFC", "INP", "JMP", "INP", "CAL", "INP", "JFZ", "INP", "CFZ", "INP", "JMP", "INP", "CAL", "INP",
		 "JFS", "OUT", "CFS", "OUT", "JMP", "OUT", "CAL", "OUT", "JFP", "OUT", "CFP", "OUT", "JMP", "OUT", "CAL", "OUT",
		 "JTC", "OUT", "CTC", "OUT", "JMP", "OUT", "CAL", "OUT", "JTZ", "OUT", "CTZ", "OUT", "JMP", "OUT", "CAL", "OUT",
		 "JTS", "OUT", "CTS", "OUT", "JMP", "OUT", "CAL", "OUT", "JTP", "OUT", "CTP", "OUT", "JMP", "OUT", "CAL", "OUT",
		 "ADA", "ADB", "ADC", "ADD", "ADE", "ADH", "ADL", "ADM", "ACA", "ACB", "ACC", "ACD", "ACE", "ACH", "ACL", "ACM",
		 "SUA", "SUB", "SUC", "SUD", "SUE", "SUH", "SUL", "SUM", "SBA", "SBB", "SBC", "SBD", "SBE", "SBH", "SBL", "SBM",
		 "NDA", "NDB", "NDC", "NDD", "NDE", "NDH", "NDL", "NDM", "XRA", "XRB", "XRC", "XRD", "XRE", "XRH", "XRL", "XRM",
		 "ORA", "ORB", "ORC", "ORD", "ORE", "ORH", "ORL", "ORM", "CPA", "CPB", "CPC", "CPD", "CPE", "CPH", "CPL", "CPM",
		 "LAA", "LAB", "LAC", "LAD", "LAE", "LAH", "LAL", "LAM", "LBA", "LBB", "LBC", "LBD", "LBE", "LBH", "LBL", "LBM", 
		 "LCA", "LCB", "LCC", "LCD", "LCE", "LCH", "LCL", "LCM", "LDA", "LDB", "LDC", "LDD", "LDE", "LDH", "LDL", "LDM",
		 "LEA", "LEB", "LEC", "LED", "LEE", "LEH", "LEL", "LEM", "LHA", "LHB", "LHC", "LHD", "LHE", "LHH", "LHL", "LHM",
                 "LLA", "LLB", "LLC", "LLD", "LLE", "LLH", "LLL", "LLM", "LMA", "LMB", "LMC", "LMD", "LME", "LMH", "LML", "HLT"};

unsigned int instr_l[] = { 1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 2, 1, 2, 1,
                           1, 1, 1, 1, 2, 1, 2, 1, 1, 1, 1, 1, 2, 1, 2, 1,
		           1, 1, 0, 1, 2, 1, 2, 1, 1, 1, 0, 1, 2, 1, 2, 1,
                           1, 1, 0, 1, 2, 1, 2, 1, 0, 0, 0, 1, 2, 1, 2, 1,
                           3, 4, 3, 4, 3, 4, 3, 4, 3, 4, 3, 4, 3, 4, 3, 4,
                           3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5,
                           3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5,
                           3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5, 3, 5,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
                           1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};

/***************************************************************************

 decoded opcodes


MS 2 bits
------------------------------------------------------------------------
00      load (imediate), add/subtract (imediate), increment, decrement, 
    and/or/eor/cmp (imediate), rotate, return, halt
01  jump, call, input, output
10  add/subtract (not imediate), and/or/eor/cmp (not imediate)
11  load (not imediate), halt




MS 2 bits =  00  INC/DEC/ROTATE, RST/RET and IMEDIATE OPERATIONS
LS 3 bits
---------------------------------------------------------------------
000 increment (bits 3-5 determine reg except 0 = hlt inst)

001 decrement (bits 3-5 determine reg except 0 = hlt inst)

010 rotate  (bits 3-5 specify
    000 A left
    001 A right
    010 A left through carry
    011 A right through carry
    1xx ????

011 conditional return

100 add/subtract/and/or/eor/cmp imediate
    bits 3-5
    000 add w/o carry
    001 add w carry
    010 subtract w/o borrow
    011 subtract w borrow
    100 and
    101 xor
    110 or
    111 cmp

101 RST -call routine in low mem (address = inst & 0x38)

110 load imediate(bits 3-5 determine dest)

111 unconditional return


MS 2 bits =  01  I/O, JUMP AND CALL
LS 3 bits
---------------------------------------------------------------------
000 jump conditionally
XX1 input/output
010 call conditionally
100 jump
110 call

MS 2 bits =  10   MATH AND BOOLEAN OPERATIONS
bits 3-5
---------------------------------------------------------------------
000 add (bit 0-2 determines source)
001 add w/carry (bit 0-2 determines source)
010 subtract (bit 0-2 determines source)
011 subtract w/borrow (bit 0-2 determines source)
100 and (bit 0-2 determines source)
101 eor (bit 0-2 determines source)
110 or (bit 0-2 determines source)
111 cmp (bit 0-2 determines source)

MS 2 bits =  11  LOAD INSTRUCTION
---------------------------------------------------------------------
XXX load (bits 0-5 determine src/dest,except 0xFF = halt)

*********************************************************************/
int imediateplus(unsigned char inst);
int iojmpcall(unsigned char inst);
int mathboolean(unsigned char inst);
int load(unsigned char inst);
int chkconditional (unsigned char inst);
void platform_IO(unsigned char inst);
void setflags (int result, int carryzero);
void outchar8008(char outchar) ;
//unsigned char inchar8008();
void reset ();
int execute ();
void setflagsinc (int result);
void setparity (int result);

unsigned long instructions =0;
unsigned long fetches =0;
unsigned int outbitcnt=0;
unsigned int inbitcnt=0;


//Acknowledgment: Thanks goes to the following webpages which provided the
//info needed to read the arrow keys from the keyboard (used in getKeyPress):
//	http://www.daniweb.com/software-development/cpp/code/216732
//	http://www.codingforums.com/archive/index.php/t-100973.html
char getKeyPress()
{
	char key = 127;

	key = _getch();
	
	if (key == 0 || key == -32)  //get a special key
	{
		key = _getch();

		if (key == 72) //up arrow
		{
			key = 'u';
		}
		else if (key == 75) //left arrow
		{
			key = 'l';
		}
		else if (key == 77) //right
		{
			key = 'r';
		}
		else if (key == 80) //down
		{
			key = 'd';
		}
	}
	return key;
}

int main (int argc, char **argv)
{
    int halted=0;
    int debug =1;
    int octal=1;
    int next=0;
    int nxtstkptr = 0;
    int cmdmode = 0;
    unsigned int dmpadr;
    unsigned int temp,temp1;
    char input;
    int i, cnt;  
    unsigned int starting_stack_ptr;
    char string [256];
    unsigned int address;
    unsigned int size;
    unsigned int type;
    unsigned int data;
    unsigned int brkpt;

    starting_stack_ptr=0x40;

    if ((argc != 2 && argc != 3)) {
        printf ("wrong number of arguments - %d provided - must be  one: binary input file\n", argc-1);
        exit(-1);
    }

//		printf("%s\n",argv[1]);
//		printf("%d\n",argv[2]);
        infile=fopen(argv[1], "r");

	if (argc == 3) {
		sscanf (argv[2],"%d",&starting_stack_ptr);
		printf ("starting address %s, %o\n",argv[2],starting_stack_ptr);
    		stack.stk[0]=i;
	}

        
    if (infile == NULL) {
        printf("error opening input file %s\n",argv[1]);
        exit(-1);
    }

/* read in program from intel hex file */
    while (fscanf(infile,":%s\n",string) != EOF) {
                printf ("%s\n",string);
                sscanf (string,"%2x",&size);
                sscanf (&string[2],"%4x",&address);
                sscanf (&string[6],"%2x",&type);
                printf ("size:%x, address:%x, type:%x  ",size, address, type);
        for (i = 0; i<size; i++) {
                    sscanf (&string[8+i*2],"%2x",&data);
                    memory[address+i]=data;
         //           printf ("%2x ",memory[address+i]);
        }
                printf ("\n");
        }
        fclose(infile);
        
/* reset virutal 8008 */
    reset();
        stack.stk[stackptr]=starting_stack_ptr;
/* now start running program */
    while (1) {

        if (halted) {
            printf ("halted\n");
            debug =1;
        }
        /* figure out if we should stop whenexecuting next  command */
        if (next == 1) {
            /* if same or higher stack level, then break */
            if ((stackptr == nxtstkptr) || (((nxtstkptr - 1) & 0x7) == stackptr)) {
                debug =1;
                next =0;
            }
        }
        if (debug || (brkpt == stack.stk[stackptr])) {
            debug = 1;
            if (octal) {
                printf ("\n%3.3o-%3.3o %s %3.3o",
                    stack.stk[stackptr]>>8, stack.stk[stackptr]&0xff,
			mnems[memory[stack.stk[stackptr]]],
			memory[stack.stk[stackptr]+1]);
            } else {
                printf ("\n%4.4x %s",
                        stack.stk[stackptr],
                        mnems[memory[stack.stk[stackptr]]]);
            }
            if (octal) {
                printf ("\tA:%3.3o B:%3.3o C:%3.3o D:%3.3o E:%3.3o H:%3.3o L:%3.3o\n",
                        regs.r.regA,
                        regs.r.regB,
                        regs.r.regC,
                        regs.r.regD,
                        regs.r.regE,
                        regs.r.regH,
                        regs.r.regL);
            } else {
                printf ("\tA:%2.2x B:%2.2x C:%2.2x D:%2.2x E:%2.2x H:%2.2x L:%2.2x\n",
                        regs.r.regA,
                        regs.r.regB,
                        regs.r.regC,
                        regs.r.regD,
                        regs.r.regE,
                        regs.r.regH,
                        regs.r.regL);
            }
            printf ("\t\tzero:%1.1x carry:%1.1x sign:%1.1x parity:%1.1x\n",
                    flagZero,
                    flagCarry,
                    flagSign,
                    flagParity);
            printf ("\t\tstackptr:%2.2x",stackptr);
            printf ("\tstack:");
            for (i = 0; i<8; i++) {
                if (octal) {
                    printf("%3.3o-%3.3o ",stack.stk[i]>>8,stack.stk[i]&0xff);
                } else {
                    printf("%4.4x ",stack.stk[i]);  
                }

            }

            cmdmode =1;
            while (cmdmode) {
                printf ("\n");
                printf ("\t\tenter r:run s:step b:set break d:dump n:step over u:disassemble x:exit");
		
//		struct termios oldt;
//		if (tcgetattr(0, &oldt) == -1)  /*store old settings */
//                {
//			printf("tcgetattrerr\n");
//                }
//		oldt.c_lflag &= ~(ICANON | ECHO); /* make one change to old settings in new settings */
//		if (tcsetattr(0, TCSANOW, &oldt) == -1) /*apply the new settings immediatly */
//                {
//			printf("tcgetattrerr\n");
//                }
		input = getch(); /* standard getchar call */
//		oldt.c_lflag |= (ICANON | ECHO); /* make one change to old settings in new settings */
//		if (tcsetattr(0, TCSANOW, &oldt) == -1) /*reapply the old settings */
//                {
//			printf("tcsetattrerr(2)\n");
//                }

                switch (input) {
                    case 'b':
                        printf("\tenter break address:");
                        if (octal) {
                            scanf("%o-%o",&temp,&temp1);
                            brkpt=temp*256+temp1;
                            printf ("\nbreak set at %3.3o-%3.3o",brkpt/256,brkpt &0xff);
                        }else {
                            scanf("%4x",&brkpt);
                            printf ("\nbreak set at %x",brkpt);                         
                        }
                        break;
                    case 'd':
                        printf("\tenter dump address:");
                        if (octal) {
                            scanf("%o-%o",&temp,&temp1);
                            dmpadr=temp*256+temp1;
                            printf ("\ndump from %3.3o-%3.3o",dmpadr/256,dmpadr &0xff);
                        }else {
                            scanf("%4x",&dmpadr);
                            printf ("\ndump from at %x",dmpadr);                            
                        }
                        printf("\tenter dump length:");
                        if (octal) {
                            scanf("%o",&temp);
                        }else {
                            scanf("%4x",&temp);                         
                        }
                        i=temp;
                        while (i>0) {
                            printf("\n");
                            if (octal) {
                                printf("%3.3o-%3.3o:",dmpadr/256,dmpadr &0xff);
                            } else {
                                printf("%4.4x:",dmpadr);
                            }
                            for (temp=0; temp<16; temp++) {
                                if (octal) {
                                    printf("%3.3o ",memory[dmpadr++]);
                                } else {
                                    printf("%2.2x ",memory[dmpadr++]);
                                }
                                
                            }
                            i = i-16;
                        }
                        break;
                    case 'r':
                        printf("running \n");
                        debug = 0;
                        cmdmode =0;
                        break;
                    case 's':
                        cmdmode =0;
                        debug=1;
                        break;
                    case 'n':
                        next =1;
                        debug=0;
                        nxtstkptr=stackptr;
                        cmdmode =0;
                        break;
                    case 'h':
                        octal =0;
                        break;
                    case 'o':
                        octal =1;
                        break;
                    case 'u':   /* disassemble regular style */
                    case 'a':   /* disassemble - into source style */
                        printf("\tenter disassemble address:");
                        if (octal) {
                            scanf("%o-%o",&temp,&temp1);
                            dmpadr=temp*256+temp1;
                            printf ("\ndump from %3.3o-%3.3o",dmpadr/256,dmpadr &0xff);
                        }else {
                            scanf("%4x",&dmpadr);
                            printf ("\ndump from at %x",dmpadr);                            
                        }
                        printf("\tenter disassemble length:");
                        if (octal) {
                            scanf("%o",&temp);
                        }else {
                            scanf("%4x",&temp);                         
                        }
                        i=temp;

			if (input == 'a') {
				printf (" ORG %3.3o#%3.3o", dmpadr/256, dmpadr & 0xff);
			}

                        while (i>0) {
			    cnt = instr_l[memory[dmpadr]];
                            printf("\n");
			    if (input == 'u') {
                            	printf("%3.3o-%3.3o  %3.3o ", dmpadr/256, dmpadr & 0xff,
						 memory[dmpadr]);
			    }
                            printf(" %s", mnems[memory[dmpadr]]);
			    dmpadr++;
			    i--; 
		            switch (cnt) {
				case (2): /* immediate */
					printf (" %3.3o", memory[dmpadr]);
			                dmpadr++;
			                i--; 
					break;
				case (3): /* jmp or call */
			    		if (input == 'u') {
					    printf (" %3.3o-%3.3o", memory[dmpadr+1], memory[dmpadr]);
					} else {
					    printf (" %3.3o#%3.3o", memory[dmpadr+1], memory[dmpadr]);
					}
			                dmpadr = dmpadr + 2;
			                i = i - 2; 
					break;
				case (4): /* input */
			    		if (input == 'u') {
					    printf (" %o", (memory[dmpadr-1] >> 1) & 0x7);
					} else {
					    printf (" %3.3o", (memory[dmpadr-1] >> 1) & 0x7);
     					}
					break;
				case (5): /* output */
			    		if (input == 'u') {
					    printf (" %o", ((memory[dmpadr-1] >> 1)) & 0x1f);
					} else {
					    printf (" %3.3o", ((memory[dmpadr-1] >> 1)) & 0x1f);
         				}
					break;
				default:
					break;
			    }
                        }
                        break;
                    case 'x':
                        printf("\n");
			exit(0);
			break;
                    default:
                        break;
                }
                printf ("\n");
            }
        }
        instructions++;
        halted = execute();
    }
}
void reset ()
{
    int i;
    
    regs.r.regA=0;
    regs.r.regB=0;
    regs.r.regC=0;
    regs.r.regD=0;
    regs.r.regE=0;
    regs.r.regH=0;
    regs.r.regL=0;

    for (i=0; i<8; i++) {
        stack.stk[i] = 0;
    }
    stackptr=0;
    
    outbitcnt=0;
    inbitcnt=0;
}

int execute () {
    unsigned char inst;
    unsigned int temp;
    int halted;

    inst = memory[stack.stk[stackptr]];
    stack.stk[stackptr]++;
    stack.stk[stackptr] &= 0x3fff;
    fetches++;

/* call into four major instruction subgroups for decoding */
    temp = inst >> 6;

    switch (temp) {
    case 0:
        halted = imediateplus(inst);
        break;
    case 1:
        halted = iojmpcall(inst);
        break;
    case 2:
        halted = mathboolean (inst);
        break;
    case 3:
        halted = load (inst);
        break;  
    }
    return halted;  
}

int imediateplus(unsigned char inst)
{
    unsigned int op;
    unsigned int reg;
    int oldflag;
    int carryzero;
    unsigned int sdata1, sdata2, result;
    unsigned int cc; /* condition code to check, if conditional operation */

        /* first check for halt */
        if ((inst & 0xfe) == 0x0) {
                printf ("halt:%2x\n",inst);
                return 1;
        }
        
    op = inst & 0x7;
    switch (op) {
    case 0:  /* increment */
        reg = (inst & 0x38) >>3;
        result = (int)regs.regs[reg] + 1;
        setflagsinc (result);
        regs.regs[reg] = (unsigned char)result;
        break;
    case 1: /* decrement */
        reg = (inst & 0x38) >>3;
        result = (int)regs.regs[reg] - 1;
        setflagsinc (result);
        regs.regs[reg] = (unsigned char)result;
        break;
    case 2: /* rotate */
        op = (inst & 0x38) >> 3;
        switch (op) {
            case 0: /* rotate left */
                result = (int)regs.r.regA << 1;
                regs.r.regA = (unsigned char)(((result >> 8) | result) & 0xff);
                                flagCarry =  regs.r.regA & 1;
                break;
            case 1: /* rotate right */
                                flagCarry =  regs.r.regA & 1;
                result = (int)(regs.r.regA >> 1);
                regs.r.regA = (unsigned char)(((regs.r.regA<<7) | result) & 0xff);
                break;
            case 2: /* rotate left through carry */
                result = (int)regs.r.regA << 1 | flagCarry;
                flagCarry = regs.r.regA >> 7;
                regs.r.regA = (unsigned char)(result & 0xff);
                break;
            case 3: /* rotate right through carry */
                result = (int)regs.r.regA >> 1 | (flagCarry << 7);
                flagCarry = regs.r.regA & 0x1;
                regs.r.regA = (unsigned char)(result & 0xff);
                break;
            default: /*  4-7 = ??? */
                break;
        }
        break;
    case 3: /* conditional return */
        cc = chkconditional (inst);
        if (cc) {
            stackptr = (stackptr - 1) & 0x7;
        }
        break;
    case 4: /* math with imediate operands */
        sdata2 = (unsigned char)regs.r.regA;  /* reg A is source and target */
        sdata1 = (unsigned char)memory[stack.stk[stackptr]]; /* source is imediate */
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        sdata1 = sdata1 & 0xff;
        sdata2 = sdata2 & 0xff;

        op = (inst>>3) & 0x7;
        switch (op) {
        case 0: /* add without carry, but set carry */
            result = sdata1 + sdata2;
//              printf ("mADD RA: %2.2x  RS: %2.2x RESULT: %2.2x",sdata2,sdata1, result);
            regs.r.regA = (unsigned char) result;
            carryzero= 0;
            break;
        case 1: /* add with carry, and set carry */
            result = sdata1 + sdata2 + flagCarry;
//              printf ("mADC RA: %2.2x  RS: %2.2x CARRYIN: %d RESULT: %2.2x",sdata2,sdata1,flagCarry, result);
            regs.r.regA = (unsigned char) result;
            carryzero= 0;
            break;
        case 2: /* subtract with no borrow, but set borrow */
            result = sdata2 - sdata1;
//              printf ("mSUB RA: %2.2x  RS: %2.2x RESULT: %2.2x",sdata2,sdata1, result);
            regs.r.regA = (unsigned char) result;
            carryzero= 0;
            break;
        case 3: /* subtract with borrow, and set borrow */
            result = sdata2 - sdata1 -flagCarry;
//              printf ("mSBC RA: %2.2x  RS: %2.2x CARRYIN: %d RESULT: %2.2x",sdata2,sdata1,flagCarry, result);
            regs.r.regA = (unsigned char) result;
            carryzero= 0;
            break;
        case 4: /* logical and */
            result = sdata1 & sdata2;
            regs.r.regA = (unsigned char) result;
            carryzero= 1;
            break;
        case 5: /* exclusive or */
            result = sdata1 ^ sdata2;
            regs.r.regA = (unsigned char) result;
            carryzero= 1;
            break;
        case 6: /* or */
            result = sdata1 | sdata2;
            regs.r.regA = (unsigned char) result;
            carryzero= 1;
            break;
        case 7: /* compare (assume no borrow for now) */
            result = sdata2 - sdata1;
//          printf ("mCMP RA: %2.2x  RS: %2.2x CARRYIN: %d RESULT: %2.2x",sdata2,sdata1,flagCarry, result);

            carryzero= 0;
            break;
        }
        setflags (result, carryzero);
        break;
    case 5:  /* RST (call function in low memory) */
        stackptr = (stackptr + 1) & 0x7;
                stack.stk[stackptr] = (inst & 0x38) & 0x3fff;
        break;
    case 6: /* load imediate */
        sdata1 = memory[stack.stk[stackptr]]; /* source is imediate */
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        reg = (inst >> 3) & 0x7;
        if (reg == 7) {
            memory[((regs.r.regH&0x3f)<<8)+regs.r.regL]=sdata1;
        } else {
            regs.regs[reg] = sdata1;
        }
        break;
    case 7: /* unconditional return */
        stackptr = (stackptr - 1) & 0x7;
        break;
    }
    return 0;
}

int iojmpcall(unsigned char inst)
{
    unsigned int op;
    unsigned int cc; /* condition code to check, if conditional operation */
    unsigned int addrL,addrH;

    op = inst & 0x7;
    switch (op) {
    case 0: /* jump conditionally */
        cc = chkconditional (inst);
        addrL = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        addrH = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        if (cc) {
            stack.stk[stackptr] = (addrL + (addrH<<8)) & 0x3fff;
        }
        break;
    case 2: /* call conditionally */
        cc = chkconditional (inst);
        addrL = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        addrH = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        if (cc) {
            /* now bump stack to use new pc and save it */
            stackptr = (stackptr + 1) & 0x7;
            stack.stk[stackptr] = (addrL + (addrH<<8)) & 0x3fff;
        }
        break;
    case 4: /* jump */
        addrL = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        addrH = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr] = (addrL + (addrH<<8)) & 0x3fff;
        fetches++;


        break;
    case 6: /* call */
        addrL = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        addrH = (unsigned int)memory[stack.stk[stackptr]];
        stack.stk[stackptr]++;
        stack.stk[stackptr] &= 0x3fff;
        fetches++;

        /* now bump stack to use new pc and save it */
        stackptr = (stackptr + 1) & 0x7;
        stack.stk[stackptr] = (addrL + (addrH<<8)) & 0x3fff;
        break;
    default: /* I/O - TBD*/
                platform_IO(inst);
        break;
    }
    return 0;
}

int mathboolean(unsigned char inst)
{
    unsigned int src, op;
    int carryzero;
    unsigned int sdata1, sdata2, result;

    src = inst & 0x7;
    if (src == 0x7) {
        sdata1 = memory[((regs.r.regH&0x3f)<<8)+regs.r.regL];
    } else {
        sdata1 = regs.regs[src];
    }
    sdata1 = sdata1 & 0xff;
    sdata2 = (char)regs.r.regA;  /* reg A is other source and usually target */
    sdata2 = sdata2 & 0xff;
    

    op = (inst>>3) & 0x7;
    switch (op) {
    case 0: /* add without carry, but set carry */
        result = sdata1 + sdata2;
        regs.r.regA = (unsigned char) result;
        carryzero = 0;
//          printf (" ADD RA: %2.2x  RS: %2.2x RESULT: %2.2x",sdata2,sdata1,result);
        break;

    case 1: /* add with carry, and set carry */
        result = sdata1 + sdata2 + flagCarry;
        regs.r.regA = (unsigned char) result;
        carryzero = 0;
//          printf (" ADC RA: %2.2x  RS: %2.2x CARRYIN: %d RESULT: %2.2x",sdata2,sdata1,flagCarry, result);
        break;

    case 2: /* subtract with no borrow, but set borrow */
        result = sdata2 - sdata1;
        regs.r.regA = (unsigned char) result;
        carryzero = 0;
            
//      printf (" SUB RA: %2.2x  RS: %2.2x RESULT: %2.2x",sdata2,sdata1,result);
        break;
    case 3: /* subtract with borrow, and set borrow */
        result = sdata2 - sdata1 -flagCarry;
        regs.r.regA = (unsigned char) result;
        carryzero = 0;
//          printf (" SBC RA: %2.2x  RS: %2.2x BORROWIN: %d RESULT: %2.2x",sdata2, sdata1, flagCarry, result);
        break;
    case 4: /* logical and */
        result = sdata1 & sdata2;
        regs.r.regA = (unsigned char) result;
        carryzero = 1;
        break;
    case 5: /* exclusive or */
        result = sdata1 ^ sdata2;
        regs.r.regA = (unsigned char) result;
        carryzero = 1;
        break;
    case 6: /* or */
        result = sdata1 | sdata2;
        regs.r.regA = (unsigned char) result;
        carryzero = 1;
        break;
    case 7: /* compare (assume no borrow for now) */
//      printf (" CMP RA: %2.2x  RS: %2.2x RESULT: %2.2x",sdata2,sdata1,result);

        result = sdata2 - sdata1;
        carryzero = 0;
        break;
    }
    setflags (result, carryzero);
    return 0;
}

void setflags (int result, int carryzero)
{

    
    if (result & 0xff) {
        flagZero = 0;
        if (result & 0x80) {
            flagSign = 1;
        } else {
            flagSign = 0;
        }
    } else {
        flagSign = 0;
        flagZero = 1;
    }
    if (carryzero) {
        flagCarry =0;
    } else if (result > 255 || result < 0) {
//      printf(" Carryout\n");
        flagCarry = 1;
    } else {
//      printf(" NO Carryout\n");
        flagCarry = 0;
    }
    setparity (result);
    return;
}

void setflagsinc (int result)
{
    if (result & 0xff) {
        flagZero = 0;
        if (result & 0x80) {
            flagSign = 1;
        } else {
            flagSign = 0;
        }
    } else {
        flagSign = 0;
        flagZero = 1;
    }
    setparity (result);
    return;
}

void setparity (int result)
{
    int i, p;

    p=0;
    flagParity = 1;
    for (i = 0; i<8; i++) {
        flagParity = flagParity ^ ((result>>i) & 1);
        if (result & (1<<i)) {
            p++;
        }
    }
    if (p & 1) {
        flagParity = 0;
    }
}

int load(unsigned char inst)
{
    unsigned int src,dest;
    unsigned char data;

    src = inst & 0x7;
    dest = (inst>>3) & 0x7;

    if (src == 0x7 && dest == 0x7) {
        printf ("halt:%2x\n",inst);
        return 1;
    }
    if (src == 0x7) {
        data = memory[((unsigned int)(regs.r.regH&0x3f)<<8)+regs.r.regL];
    } else {
        data = regs.regs[src];
    }
    if (dest == 0x7) {
        memory[((unsigned int)(regs.r.regH&0x3f)<<8)+regs.r.regL] = data;
    } else {
        regs.regs[dest] = data;
    }
    return 0;
}

int chkconditional (unsigned char inst)
{
    unsigned int cc;
    cc = (inst & 0x38) >> 3;

    switch (cc) {
    case 0: /* overflow false */
        cc = !flagCarry;
        break;
    case 1: /* zero false */
        cc = !flagZero;
        break;
    case 2: /* sign false */
        cc = !flagSign;
        break;
    case 3: /* parity false */
        cc = !flagParity;
        break;
    case 4: /* overflow true */
        cc = flagCarry;
        break;
    case 5: /* zero true */
        cc = flagZero;
        break;
    case 6: /* sign true */
        cc = flagSign;
        break;
    case 7: /* parity true */
        cc = flagParity;
        break;
    }
    return (cc);
}


unsigned char outchar;
unsigned char inchar;
void platform_IO(unsigned char inst)
{
    switch (inst) {


    case 0x55: /*output 12 - serial output */
    case 0x5d: /*output 16 */
        outbitcnt++;
        if (outbitcnt == 1) {
            break;
        } else if (outbitcnt == 10) {
            outchar8008(outchar&0x7f);
            outbitcnt = 0;
            break;
        } else {
            outchar = ((outchar >> 1) & 0x7F) | ((regs.r.regA & 0x01) <<7);
        }
        break;



    case 0x4b: /*input - emulate serial input */
    case 0x43: /*input - port 1 */
        inbitcnt++;
        // printf("\ninbitcnt:%d rega:%x regb:%x\n",inbitcnt,regs.r.regA,regs.r.regB);
        if (inbitcnt == 1) {
            inchar =getKeyPress()|0x80;//inchar8008();getchar()
            regs.r.regA = 0x00;     /* set start bit */
        } else if (inbitcnt == 9) {
            regs.r.regA = (inchar << (9-inbitcnt)) & 0x80;
            inbitcnt =0;
        } else {
            regs.r.regA = (inchar << (9-inbitcnt)) & 0x80;
        }
        break; 


    case 0x59: /* out 2 output 131 parallel output */
        outchar8008(regs.r.regA);
        outbitcnt =0;
        break;


    case 0x45: /* in 2 input 101 parallel input */
	inchar = getKeyPress()|0x80;//inchar8008();
        if (inchar) {
//            printf ("load mem:%o",inchar);
	    regs.r.regA = inchar;
	} else {
	    regs.r.regA = 0;
	}
	inbitcnt=0;
	break;
    }
}

void outchar8008(char outchar) 
{
     outchar = outchar & 0x7f;
     if (outchar == 0x0d) {
         printf ("\n");
     } else {
         printf ("%c",outchar);
     }
}

//unsigned char inchar8008()
//{
//            struct termios oldt;
//            struct termios savt;
//            unsigned char inchar;
//
//            if (tcgetattr(0, &oldt) == -1) /*store old settings */
//            {
//                printf ("tcgetatter error\n");
//                exit (-1);
//            } 
//            savt = oldt; /* copy old settings to new settings */
//            oldt.c_lflag &= ~(ICANON | ECHO); /* make one change to old settings in new settings */
//            if (tcsetattr(0, TCSANOW, &oldt) == -1)  /*apply the new settings immediatly */
//            {
//                printf ("tcsetatter error\n");
//                exit (-1);
//            } 
//            inchar = getchar(); /* standard getchar call */
//            oldt.c_lflag |= (ICANON | ECHO); /* make one change to old settings in new settings */
//            if (tcsetattr(0, TCSANOW, &oldt) == -1) /*reapply the old settings */
//            {
//                printf ("tcsetatter (2) error\n");
//                exit (-1);
//            } 
//          printf("\n%x\n",inchar);
//            inchar = inchar | 0x80;
//            return (inchar);
//}
